#include <bits/stdc++.h>
 
typedef long long ll;
using namespace std;
 
int main() {
    int n,m,i,d;
    double r,w;
    cin >> n >> m;
    double a[100001] = {0.0};
    cin >> r;
    int q[m];
    for(i = 0; i < n; i++){
        cin >> d;
        cin >> w;
        a[d-1] = w;
    }
    int maxi = -1;
    for(i = 0; i < m; i++) {
        cin >> q[i];
        if(q[i] <= 1e5) maxi = max(maxi, q[i]);
    }
    a[0] *= r;
    for(i = 1; i < maxi; i++) {
        a[i] = (1-r)*a[i-1]+r*a[i];
    }
    for(i = 0; i < maxi; i++) {
    //  cout << a[i] << ' ';
    }
    //cout << endl;
    for(i = 0; i < m; i++) {
        if(q[i] > 1e5){
            cout << 0 << ' ';
        }   
        else
            cout << fixed << setprecision(6)<< a[q[i]-1] << ' ';
    }
}
